.include "2313def.inc"

.def Temp1=R16
.def Temp2=R17
.def Temp3=R18 
.def st1=R19 
.def st2=R20 
.def st3=R21
.def st4=R22 
.def st5=R23 
.def st6=R24 
;.def sek=R25
.def presskey=R26 
.def hor=R27
.def Temp4=R28 

.cseg
.org 0

	rjmp Reset
	RETI ;INT_0
	RETI ;INT_1
	RETI ;Timer1_capt1
	rjmp Timer1_comp1
	RETI ;Timer1_OVF1
;****************************************************************************
Reset:
	CLI
ldi Temp1,RamEnd
out SPL,Temp1 ;  

ldi Temp1,0b00111111
out ddrb, Temp1 ;   b

ldi Temp1,0b01001111
out ddrd, Temp1 ;   d

ldi Temp1,0b01000000
out Timsk,Temp1 ;  
;***************************************************************************
ldi Temp1,0x7a
out Ocr1ah,Temp1
ldi Temp1,0x12
out Ocr1al,Temp1 ;   31250 [8'000'000/(256*31250)=1.  8]

ldi Presskey,0 ;   

	CLR	ST1	;  
	CLR	ST2	;  
	CLR	ST3	;  
	CLR	ST4	;  
	CLR	ST5	;  
	CLR	ST6	;  
	
	CLR	HOR
	OUT Tcnt1h,HOR
	OUT Tcnt1l,HOR ; 

ldi Temp1,0b00001100
out Tccr1b,Temp1 ;  /256

sei ;   

;********************  *********************************************************
Cycle:
rcall Display
rcall Press
rjmp Cycle
;******************************************
Display:

ldi Temp1, 0b00011111
out Portb,Temp1
mov Temp1,st1
out Portd,Temp1
rcall Delay ;  1-  (.)  

ldi Temp1, 0b00101111
out Portb,Temp1
mov Temp1,st2
out Portd,Temp1
rcall Delay ;  2-   

ldi Temp1, 0b00110111
out Portb,Temp1
mov Temp1,st3
out Portd,Temp1
rcall Delay ;  3-   

ldi Temp1, 0b00111011
out Portb,Temp1
mov Temp1,st4
out Portd,Temp1
rcall Delay ;  4-   

ldi Temp1, 0b00111101
out Portb,Temp1
mov Temp1,st5
out Portd,Temp1
rcall Delay ;  5-   

ldi Temp1, 0b00111110
out Portb,Temp1
mov Temp1,st6
out Portd,Temp1
rcall Delay ;  6-   

ret
;**************************************************
Delay:
	LDI	ZH,0x01
	CLR	ZL
DLL:
	SBIW	ZL,1
	BRNE	DLL
	
	RET
;**********************************************************
Timer1_comp1:
SEK_1:
	INC ST6 ;  
	CPI ST6,10
	BRLO Out3 ;     
;**********
SEK_10:
	CLR	ST6
	INC	ST5
	CPI	ST5,6
	BRLO	OUT3
; 60 =1
MIN_1:
	CLR	ST5
KEY_MIN:
	INC	ST4
	CPI	ST4,10
	BRLO	OUT3		;   0...9
;*********
MIN_10:
	CLR	ST4
	INC	ST3
	CPI	ST3,6
	BRLO	OUT3
; 60 =1
HOR_1:
	CLR	ST3
KEY_HOR:
	INC	HOR
	CPI	HOR,24
	BRLO	HOR_GO
	
	RJMP	RESET
	
HOR_GO:
	INC	ST2
	CPI	ST2,10
	BRLO	OUT3		;   0...9
;*********
	CLR	ST2
	INC	ST1
	CPI	ST1,3
	BRLO	OUT3
	CLR	ST2
	CLR	ST1	
out3:
	RETI

;************************** **************
Press:
in Temp1,PinD ;   d
           ori r16,0b11001111               ;
           cpi r16,0b11101111 
           breq Press_min 
           cpi r16,0b11011111
           breq Press_hor
           rjmp Nobut  
Press_min:     
           cpi Presskey,1 
	   breq Outpress
	   ldi Presskey,1 
           RJMP KEY_MIN
           RJMP Outpress
Press_hor:          
           cpi Presskey,2 
	   breq Outpress
	   ldi Presskey,2
           RJMP KEY_HOR 
           RJMP Outpress     ;

Nobut:
ldi Presskey,0 ;   
	RJMP Outpress

Outpress:
ret
;**********************************************************

	   









